package cc.fascinated.bat.features.base.commands.general.avatar;

import cc.fascinated.bat.command.BatCommand;
import cc.fascinated.bat.command.Category;
import cc.fascinated.bat.command.CommandInfo;
import cc.fascinated.bat.common.EmbedUtils;
import cc.fascinated.bat.model.BatGuild;
import cc.fascinated.bat.model.BatUser;
import lombok.NonNull;
import net.dv8tion.jda.api.entities.Member;
import net.dv8tion.jda.api.entities.channel.middleman.MessageChannel;
import net.dv8tion.jda.api.interactions.commands.SlashCommandInteraction;
import net.dv8tion.jda.api.utils.ImageProxy;
import org.springframework.stereotype.Component;

/**
 * @author Nick (okNick)
 */
@Component("avatar:guild.sub")
@CommandInfo(name = "guild", description = "View the avatar of the guild", category = Category.GENERAL)
public class GuildSubCommand extends BatCommand {
    @Override
    public void execute(BatGuild guild, @NonNull BatUser user, @NonNull MessageChannel channel, Member member, @NonNull SlashCommandInteraction event) {
        ImageProxy icon = guild.getDiscordGuild().getIcon();

        if (icon == null) {
            event.replyEmbeds(EmbedUtils.errorEmbed()
                            .setDescription("**%s** does not have an avatar!".formatted(guild.getName()))
                            .build())
                    .queue();
            return;
        }

        event.replyEmbeds(EmbedUtils.genericEmbed()
                .setAuthor("%s's Avatar".formatted(guild.getName()), null, guild.getDiscordGuild().getIconUrl())
                .setImage(icon.getUrl(4096))
                .build()
        ).queue();
    }
}