package cc.fascinated.bat.features.base.commands.server.feature;

import cc.fascinated.bat.command.BatCommand;
import cc.fascinated.bat.command.CommandInfo;
import cc.fascinated.bat.common.EmbedUtils;
import cc.fascinated.bat.features.Feature;
import cc.fascinated.bat.features.base.profile.FeatureProfile;
import cc.fascinated.bat.model.BatGuild;
import cc.fascinated.bat.model.BatUser;
import cc.fascinated.bat.service.FeatureService;
import lombok.NonNull;
import net.dv8tion.jda.api.entities.Member;
import net.dv8tion.jda.api.entities.channel.middleman.MessageChannel;
import net.dv8tion.jda.api.interactions.commands.SlashCommandInteraction;
import org.springframework.stereotype.Component;

/**
 * @author Fascinated (fascinated7)
 */
@Component("feature:list.sub")
@CommandInfo(name = "list", description = "Lists the features and their states")
public class ListSubCommand extends BatCommand {
    @Override
    public void execute(BatGuild guild, @NonNull BatUser user, @NonNull MessageChannel channel, Member member, @NonNull SlashCommandInteraction event) {
        StringBuilder featureStates = new StringBuilder();
        for (Feature feature : FeatureService.INSTANCE.getFeaturesSorted()) {
            FeatureProfile featureProfile = guild.getFeatureProfile();
            featureStates.append("%s `%s`\n".formatted(
                    featureProfile.getFeatureState(feature).getEmoji(),
                    feature.getName()
            ));
        }
        event.replyEmbeds(EmbedUtils.genericEmbed()
                .setTitle("Feature List")
                .setDescription(featureStates.toString())
                .build()
        ).queue();
    }
}
