package cc.fascinated.bat.features.welcomer;

import cc.fascinated.bat.event.EventListener;
import cc.fascinated.bat.model.BatGuild;
import cc.fascinated.bat.model.BatUser;
import lombok.NonNull;
import net.dv8tion.jda.api.events.guild.member.GuildMemberJoinEvent;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

/**
 * @author Fascinated (fascinated7)
 */
@Component
public class WelcomerListener implements EventListener {
    private final WelcomerFeature welcomerFeature;

    @Autowired
    public WelcomerListener(WelcomerFeature welcomerFeature) {
        this.welcomerFeature = welcomerFeature;
    }

    @Override
    public void onGuildMemberJoin(@NonNull BatGuild guild, @NonNull BatUser user, @NonNull GuildMemberJoinEvent event) {
        if (guild.getFeatureProfile().isFeatureDisabled(welcomerFeature)) { // Check if the feature is disabled
            return;
        }

        WelcomerProfile profile = guild.getWelcomerProfile();
        profile.sendWelcomeMessage(guild, user);
    }
}
